﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ViewModelBinding
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
    }
    public class StaffMemberViewModel : INotifyPropertyChanged
    {
        ObservableCollection<StaffMember> _staffMembers;
        public ObservableCollection<StaffMember> StaffMembers
        {
            get { return _staffMembers; }
            set
            {
                _staffMembers = value;
                RaisePropertyChanged("StaffMembers");
            }
        }
            public StaffMemberViewModel()
        {
            PopulateStaffMembers();
        }

        void PopulateStaffMembers()
        {
            var list = new ObservableCollection<StaffMember>();
            var rand = new Random();

            for (Int32 i = 1; i < 4; i++)
            {
                var member = new StaffMember { Name = String.Format("Name {0}", i), Department = String.Format("Department {0}", i) };
                for (int j = 1; j < 5; j++)
                    member.Periods.Add(new Period { Title = String.Format("Period {0}", j), Hours = rand.Next(0, 160) });
                list.Add(member);
            }

            StaffMembers = list;
        }

        public event PropertyChangedEventHandler PropertyChanged;
        void RaisePropertyChanged(String propertyName)
        {
            var handler = this.PropertyChanged;
            if (handler != null)
                handler(this, new PropertyChangedEventArgs(propertyName));
        }

      
    }

    public class StaffMember
    {
        public String Department { get; set; }
        public String Name { get; set; }
        public IList<Period> Periods { get; set; }

        public StaffMember()
        {
            this.Periods = new List<Period>();
        }
    }

    public class Period
    {
        public string Title { get; set; }
        public int Hours { get; set; }
    }
}
